"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var apollo_link_1 = require("apollo-link");
var graphql_tag_1 = __importDefault(require("graphql-tag"));
var guessFragmentType = function (fragment) {
    var isString, isFragment = false;
    var fragmentName = '';
    if (typeof fragment === 'string') {
        isString = true;
    }
    else if (fragment instanceof Object && fragment.definitions) {
        isFragment = true;
        var definition = fragment.definitions[0];
        if (definition.kind === 'FragmentDefinition') {
            fragmentName = definition.name.value;
        }
        else {
            console.error("The argument passed is not a fragment definition, got " + definition.kind + " instead");
            return;
        }
    }
    return { isString: isString, isFragment: isFragment, fragmentName: fragmentName };
};
exports.apiProvider = function (apolloClient) {
    var abortableQuery = function (query, args) {
        var observableQuery;
        var parsedQuery = query.definitions[0];
        var queryName = parsedQuery.name.value;
        var variables = {};
        function $abort() {
            if (observableQuery && !observableQuery.closed) {
                observableQuery.unsubscribe();
            }
        }
        function $fetch() {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2, new Promise(function (resolve, reject) {
                            observableQuery = apollo_link_1.execute(apolloClient.link, {
                                query: query,
                                variables: variables
                            }).subscribe({
                                next: function (_a) {
                                    var data = _a.data, errors = _a.errors;
                                    if (data) {
                                        resolve(data[queryName]);
                                    }
                                    else {
                                        reject(errors);
                                    }
                                },
                                error: function (error) { return reject(error); }
                            });
                        })];
                });
            });
        }
        function $args(args) {
            variables = args;
            return {
                $abort: $abort,
                $fetch: $fetch
            };
        }
        if (args) {
            return {
                $abort: $abort,
                $args: $args
            };
        }
        else {
            return {
                $abort: $abort,
                $fetch: $fetch
            };
        }
    };
    var abortableMutation = function (mutation, args) {
        var observableQuery;
        var parsedQuery = mutation.definitions[0];
        var mutationName = parsedQuery.name.value;
        var variables = {};
        function $abort() {
            if (observableQuery && !observableQuery.closed) {
                observableQuery.unsubscribe();
            }
        }
        function $post() {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2, new Promise(function (resolve, reject) {
                            observableQuery = apollo_link_1.execute(apolloClient.link, {
                                query: mutation,
                                variables: variables
                            }).subscribe({
                                next: function (_a) {
                                    var data = _a.data, errors = _a.errors;
                                    if (data) {
                                        resolve(data[mutationName]);
                                    }
                                    else {
                                        reject(errors);
                                    }
                                },
                                error: function (error) { return reject(error); }
                            });
                        })];
                });
            });
        }
        function $args(args) {
            variables = args;
            return {
                $abort: $abort,
                $post: $post
            };
        }
        if (args) {
            return {
                $abort: $abort,
                $args: $args
            };
        }
        else {
            return {
                $abort: $abort,
                $post: $post
            };
        }
    };
    return {
        me: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var query = graphql_tag_1.default(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n          query me  {\n            me {\n              ", "\n            }\n          } ", "\n          "], ["\n          query me  {\n            me {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableQuery(query, false);
                }
            };
        },
        user: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var query = graphql_tag_1.default(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n          query user ($where: UserWhereUniqueInput!) {\n            user(where: $where) {\n              ", "\n            }\n          } ", "\n          "], ["\n          query user ($where: UserWhereUniqueInput!) {\n            user(where: $where) {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableQuery(query, true);
                }
            };
        },
        usersConnection: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var query = graphql_tag_1.default(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n          query usersConnection ($where: UserConnectionWhereInput,$page: Int,$limit: Int) {\n            usersConnection(where: $where,page: $page,limit: $limit) {\n              \n    pageInfo {\n        \n    hasNextPage\n    hasPreviousPage\n    startCursor\n    endCursor\n    totalPage }\n    aggregate {\n        \n    count }\n    edges {\n        \n    node{", "} }\n            }\n          } ", "\n          "], ["\n          query usersConnection ($where: UserConnectionWhereInput,$page: Int,$limit: Int) {\n            usersConnection(where: $where,page: $page,limit: $limit) {\n              \n    pageInfo {\n        \n    hasNextPage\n    hasPreviousPage\n    startCursor\n    endCursor\n    totalPage }\n    aggregate {\n        \n    count }\n    edges {\n        \n    node{", "} }\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableQuery(query, true);
                }
            };
        },
        requestResetUserPassword: function () {
            var query = graphql_tag_1.default(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n      query requestResetUserPassword ($userId: ID) {\n        requestResetUserPassword(userId: $userId)\n      }"], ["\n      query requestResetUserPassword ($userId: ID) {\n        requestResetUserPassword(userId: $userId)\n      }"])));
            return abortableQuery(query, true);
        },
        nurseriesConnection: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var query = graphql_tag_1.default(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n          query nurseriesConnection ($where: NurseryConnectionWhereInput,$page: Int,$limit: Int) {\n            nurseriesConnection(where: $where,page: $page,limit: $limit) {\n              \n    pageInfo {\n        \n    hasNextPage\n    hasPreviousPage\n    startCursor\n    endCursor\n    totalPage }\n    aggregate {\n        \n    count }\n    edges {\n        \n    node{", "} }\n            }\n          } ", "\n          "], ["\n          query nurseriesConnection ($where: NurseryConnectionWhereInput,$page: Int,$limit: Int) {\n            nurseriesConnection(where: $where,page: $page,limit: $limit) {\n              \n    pageInfo {\n        \n    hasNextPage\n    hasPreviousPage\n    startCursor\n    endCursor\n    totalPage }\n    aggregate {\n        \n    count }\n    edges {\n        \n    node{", "} }\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableQuery(query, true);
                }
            };
        },
        nursery: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var query = graphql_tag_1.default(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n          query nursery ($id: ID) {\n            nursery(id: $id) {\n              ", "\n            }\n          } ", "\n          "], ["\n          query nursery ($id: ID) {\n            nursery(id: $id) {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableQuery(query, true);
                }
            };
        },
        nurseryPlanning: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var query = graphql_tag_1.default(templateObject_7 || (templateObject_7 = __makeTemplateObject(["\n          query nurseryPlanning ($id: ID!,$start: DateTime!,$end: DateTime!) {\n            nurseryPlanning(id: $id,start: $start,end: $end) {\n              ", "\n            }\n          } ", "\n          "], ["\n          query nurseryPlanning ($id: ID!,$start: DateTime!,$end: DateTime!) {\n            nurseryPlanning(id: $id,start: $start,end: $end) {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableQuery(query, true);
                }
            };
        },
        nurseryKeyFigures: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var query = graphql_tag_1.default(templateObject_8 || (templateObject_8 = __makeTemplateObject(["\n          query nurseryKeyFigures ($id: ID!,$start: DateTime!,$end: DateTime!) {\n            nurseryKeyFigures(id: $id,start: $start,end: $end) {\n              ", "\n            }\n          } ", "\n          "], ["\n          query nurseryKeyFigures ($id: ID!,$start: DateTime!,$end: DateTime!) {\n            nurseryKeyFigures(id: $id,start: $start,end: $end) {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableQuery(query, true);
                }
            };
        },
        bansConnection: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var query = graphql_tag_1.default(templateObject_9 || (templateObject_9 = __makeTemplateObject(["\n          query bansConnection ($where: BansConnectionInput,$page: Int,$limit: Int) {\n            bansConnection(where: $where,page: $page,limit: $limit) {\n              \n    pageInfo {\n        \n    hasNextPage\n    hasPreviousPage\n    startCursor\n    endCursor\n    totalPage }\n    aggregate {\n        \n    count }\n    edges {\n        \n    node{", "} }\n            }\n          } ", "\n          "], ["\n          query bansConnection ($where: BansConnectionInput,$page: Int,$limit: Int) {\n            bansConnection(where: $where,page: $page,limit: $limit) {\n              \n    pageInfo {\n        \n    hasNextPage\n    hasPreviousPage\n    startCursor\n    endCursor\n    totalPage }\n    aggregate {\n        \n    count }\n    edges {\n        \n    node{", "} }\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableQuery(query, true);
                }
            };
        },
        document: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var query = graphql_tag_1.default(templateObject_10 || (templateObject_10 = __makeTemplateObject(["\n          query document ($id: ID) {\n            document(id: $id) {\n              ", "\n            }\n          } ", "\n          "], ["\n          query document ($id: ID) {\n            document(id: $id) {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableQuery(query, true);
                }
            };
        },
        getDocumentUrl: function () {
            var query = graphql_tag_1.default(templateObject_11 || (templateObject_11 = __makeTemplateObject(["\n      query getDocumentUrl ($where: WhereUniqueInput!) {\n        getDocumentUrl(where: $where)\n      }"], ["\n      query getDocumentUrl ($where: WhereUniqueInput!) {\n        getDocumentUrl(where: $where)\n      }"])));
            return abortableQuery(query, true);
        },
        child: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var query = graphql_tag_1.default(templateObject_12 || (templateObject_12 = __makeTemplateObject(["\n          query child ($where: ID!) {\n            child(where: $where) {\n              ", "\n            }\n          } ", "\n          "], ["\n          query child ($where: ID!) {\n            child(where: $where) {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableQuery(query, true);
                }
            };
        },
        customerMe: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var query = graphql_tag_1.default(templateObject_13 || (templateObject_13 = __makeTemplateObject(["\n          query customerMe  {\n            customerMe {\n              ", "\n            }\n          } ", "\n          "], ["\n          query customerMe  {\n            customerMe {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableQuery(query, false);
                }
            };
        },
        customer: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var query = graphql_tag_1.default(templateObject_14 || (templateObject_14 = __makeTemplateObject(["\n          query customer ($customerId: ID!) {\n            customer(customerId: $customerId) {\n              ", "\n            }\n          } ", "\n          "], ["\n          query customer ($customerId: ID!) {\n            customer(customerId: $customerId) {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableQuery(query, true);
                }
            };
        },
        customersConnection: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var query = graphql_tag_1.default(templateObject_15 || (templateObject_15 = __makeTemplateObject(["\n          query customersConnection ($where: CustomersConnectionWhereInput,$page: Int,$limit: Int) {\n            customersConnection(where: $where,page: $page,limit: $limit) {\n              \n    pageInfo {\n        \n    hasNextPage\n    hasPreviousPage\n    startCursor\n    endCursor\n    totalPage }\n    aggregate {\n        \n    count }\n    edges {\n        \n    node{", "} }\n            }\n          } ", "\n          "], ["\n          query customersConnection ($where: CustomersConnectionWhereInput,$page: Int,$limit: Int) {\n            customersConnection(where: $where,page: $page,limit: $limit) {\n              \n    pageInfo {\n        \n    hasNextPage\n    hasPreviousPage\n    startCursor\n    endCursor\n    totalPage }\n    aggregate {\n        \n    count }\n    edges {\n        \n    node{", "} }\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableQuery(query, true);
                }
            };
        },
        exportCustomers: function () {
            var query = graphql_tag_1.default(templateObject_16 || (templateObject_16 = __makeTemplateObject(["\n      query exportCustomers ($where: CustomersConnectionWhereInput) {\n        exportCustomers(where: $where)\n      }"], ["\n      query exportCustomers ($where: CustomersConnectionWhereInput) {\n        exportCustomers(where: $where)\n      }"])));
            return abortableQuery(query, true);
        },
        reservationsConnection: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var query = graphql_tag_1.default(templateObject_17 || (templateObject_17 = __makeTemplateObject(["\n          query reservationsConnection ($where: ReservationConnectionWhereInput,$page: Int,$limit: Int) {\n            reservationsConnection(where: $where,page: $page,limit: $limit) {\n              \n    pageInfo {\n        \n    hasNextPage\n    hasPreviousPage\n    startCursor\n    endCursor\n    totalPage }\n    aggregate {\n        \n    count }\n    edges {\n        \n    node{", "} }\n            }\n          } ", "\n          "], ["\n          query reservationsConnection ($where: ReservationConnectionWhereInput,$page: Int,$limit: Int) {\n            reservationsConnection(where: $where,page: $page,limit: $limit) {\n              \n    pageInfo {\n        \n    hasNextPage\n    hasPreviousPage\n    startCursor\n    endCursor\n    totalPage }\n    aggregate {\n        \n    count }\n    edges {\n        \n    node{", "} }\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableQuery(query, true);
                }
            };
        },
        reservation: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var query = graphql_tag_1.default(templateObject_18 || (templateObject_18 = __makeTemplateObject(["\n          query reservation ($id: ID!) {\n            reservation(id: $id) {\n              ", "\n            }\n          } ", "\n          "], ["\n          query reservation ($id: ID!) {\n            reservation(id: $id) {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableQuery(query, true);
                }
            };
        },
        dashboard: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var query = graphql_tag_1.default(templateObject_19 || (templateObject_19 = __makeTemplateObject(["\n          query dashboard ($start: DateTime,$end: DateTime) {\n            dashboard(start: $start,end: $end) {\n              ", "\n            }\n          } ", "\n          "], ["\n          query dashboard ($start: DateTime,$end: DateTime) {\n            dashboard(start: $start,end: $end) {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableQuery(query, true);
                }
            };
        },
        nurseryConfig: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var query = graphql_tag_1.default(templateObject_20 || (templateObject_20 = __makeTemplateObject(["\n          query nurseryConfig  {\n            nurseryConfig {\n              ", "\n            }\n          } ", "\n          "], ["\n          query nurseryConfig  {\n            nurseryConfig {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableQuery(query, false);
                }
            };
        },
        registrationsConnection: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var query = graphql_tag_1.default(templateObject_21 || (templateObject_21 = __makeTemplateObject(["\n          query registrationsConnection ($where: RegistrationWhereInput!,$page: Int,$limit: Int) {\n            registrationsConnection(where: $where,page: $page,limit: $limit) {\n              \n    pageInfo {\n        \n    hasNextPage\n    hasPreviousPage\n    startCursor\n    endCursor\n    totalPage }\n    aggregate {\n        \n    count }\n    edges {\n        \n    node{", "} }\n            }\n          } ", "\n          "], ["\n          query registrationsConnection ($where: RegistrationWhereInput!,$page: Int,$limit: Int) {\n            registrationsConnection(where: $where,page: $page,limit: $limit) {\n              \n    pageInfo {\n        \n    hasNextPage\n    hasPreviousPage\n    startCursor\n    endCursor\n    totalPage }\n    aggregate {\n        \n    count }\n    edges {\n        \n    node{", "} }\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableQuery(query, true);
                }
            };
        },
        registration: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var query = graphql_tag_1.default(templateObject_22 || (templateObject_22 = __makeTemplateObject(["\n          query registration ($where: RegistrationWhereUniqueInput!) {\n            registration(where: $where) {\n              ", "\n            }\n          } ", "\n          "], ["\n          query registration ($where: RegistrationWhereUniqueInput!) {\n            registration(where: $where) {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableQuery(query, true);
                }
            };
        },
        mailsConnection: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var query = graphql_tag_1.default(templateObject_23 || (templateObject_23 = __makeTemplateObject(["\n          query mailsConnection ($where: MailWhereInput,$page: Int,$limit: Int) {\n            mailsConnection(where: $where,page: $page,limit: $limit) {\n              \n    pageInfo {\n        \n    hasNextPage\n    hasPreviousPage\n    startCursor\n    endCursor\n    totalPage }\n    aggregate {\n        \n    count }\n    edges {\n        \n    node{", "} }\n            }\n          } ", "\n          "], ["\n          query mailsConnection ($where: MailWhereInput,$page: Int,$limit: Int) {\n            mailsConnection(where: $where,page: $page,limit: $limit) {\n              \n    pageInfo {\n        \n    hasNextPage\n    hasPreviousPage\n    startCursor\n    endCursor\n    totalPage }\n    aggregate {\n        \n    count }\n    edges {\n        \n    node{", "} }\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableQuery(query, true);
                }
            };
        },
        uploadPicture: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var mutation = graphql_tag_1.default(templateObject_24 || (templateObject_24 = __makeTemplateObject(["\n          mutation uploadPicture ($picture: Upload!) {\n            uploadPicture(picture: $picture) {\n              ", "\n            }\n          } ", "\n          "], ["\n          mutation uploadPicture ($picture: Upload!) {\n            uploadPicture(picture: $picture) {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableMutation(mutation, true);
                }
            };
        },
        deletePicture: function () {
            var mutation = graphql_tag_1.default(templateObject_25 || (templateObject_25 = __makeTemplateObject(["\n      mutation deletePicture ($id: ID!) {\n        deletePicture(id: $id)\n      }"], ["\n      mutation deletePicture ($id: ID!) {\n        deletePicture(id: $id)\n      }"])));
            return abortableMutation(mutation, true);
        },
        login: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var mutation = graphql_tag_1.default(templateObject_26 || (templateObject_26 = __makeTemplateObject(["\n          mutation login ($data: LoginInput) {\n            login(data: $data) {\n              ", "\n            }\n          } ", "\n          "], ["\n          mutation login ($data: LoginInput) {\n            login(data: $data) {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableMutation(mutation, true);
                }
            };
        },
        resetUserPassword: function () {
            var mutation = graphql_tag_1.default(templateObject_27 || (templateObject_27 = __makeTemplateObject(["\n      mutation resetUserPassword ($data: ResetUserPasswordInput) {\n        resetUserPassword(data: $data)\n      }"], ["\n      mutation resetUserPassword ($data: ResetUserPasswordInput) {\n        resetUserPassword(data: $data)\n      }"])));
            return abortableMutation(mutation, true);
        },
        updateUser: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var mutation = graphql_tag_1.default(templateObject_28 || (templateObject_28 = __makeTemplateObject(["\n          mutation updateUser ($user: UpdateUserInput) {\n            updateUser(user: $user) {\n              ", "\n            }\n          } ", "\n          "], ["\n          mutation updateUser ($user: UpdateUserInput) {\n            updateUser(user: $user) {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableMutation(mutation, true);
                }
            };
        },
        activateUser: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var mutation = graphql_tag_1.default(templateObject_29 || (templateObject_29 = __makeTemplateObject(["\n          mutation activateUser ($data: ActivateUserInput) {\n            activateUser(data: $data) {\n              ", "\n            }\n          } ", "\n          "], ["\n          mutation activateUser ($data: ActivateUserInput) {\n            activateUser(data: $data) {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableMutation(mutation, true);
                }
            };
        },
        deleteUser: function () {
            var mutation = graphql_tag_1.default(templateObject_30 || (templateObject_30 = __makeTemplateObject(["\n      mutation deleteUser ($userId: ID!) {\n        deleteUser(userId: $userId)\n      }"], ["\n      mutation deleteUser ($userId: ID!) {\n        deleteUser(userId: $userId)\n      }"])));
            return abortableMutation(mutation, true);
        },
        createUser: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var mutation = graphql_tag_1.default(templateObject_31 || (templateObject_31 = __makeTemplateObject(["\n          mutation createUser ($user: CreateUserInput!) {\n            createUser(user: $user) {\n              ", "\n            }\n          } ", "\n          "], ["\n          mutation createUser ($user: CreateUserInput!) {\n            createUser(user: $user) {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableMutation(mutation, true);
                }
            };
        },
        updateNursery: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var mutation = graphql_tag_1.default(templateObject_32 || (templateObject_32 = __makeTemplateObject(["\n          mutation updateNursery ($id: ID!,$data: UpdateNurseryInput!) {\n            updateNursery(id: $id,data: $data) {\n              ", "\n            }\n          } ", "\n          "], ["\n          mutation updateNursery ($id: ID!,$data: UpdateNurseryInput!) {\n            updateNursery(id: $id,data: $data) {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableMutation(mutation, true);
                }
            };
        },
        createBan: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var mutation = graphql_tag_1.default(templateObject_33 || (templateObject_33 = __makeTemplateObject(["\n          mutation createBan ($where: CreateBanWhereInput!,$data: CreateBanInput!) {\n            createBan(where: $where,data: $data) {\n              ", "\n            }\n          } ", "\n          "], ["\n          mutation createBan ($where: CreateBanWhereInput!,$data: CreateBanInput!) {\n            createBan(where: $where,data: $data) {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableMutation(mutation, true);
                }
            };
        },
        deleteBan: function () {
            var mutation = graphql_tag_1.default(templateObject_34 || (templateObject_34 = __makeTemplateObject(["\n      mutation deleteBan ($where: BanWhereUniqueInput!) {\n        deleteBan(where: $where)\n      }"], ["\n      mutation deleteBan ($where: BanWhereUniqueInput!) {\n        deleteBan(where: $where)\n      }"])));
            return abortableMutation(mutation, true);
        },
        createDocument: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var mutation = graphql_tag_1.default(templateObject_35 || (templateObject_35 = __makeTemplateObject(["\n          mutation createDocument  {\n            createDocument {\n              ", "\n            }\n          } ", "\n          "], ["\n          mutation createDocument  {\n            createDocument {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableMutation(mutation, false);
                }
            };
        },
        updateDocument: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var mutation = graphql_tag_1.default(templateObject_36 || (templateObject_36 = __makeTemplateObject(["\n          mutation updateDocument ($where: WhereUniqueInput!,$data: DocumentStatusUpdateDataInput!) {\n            updateDocument(where: $where,data: $data) {\n              ", "\n            }\n          } ", "\n          "], ["\n          mutation updateDocument ($where: WhereUniqueInput!,$data: DocumentStatusUpdateDataInput!) {\n            updateDocument(where: $where,data: $data) {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableMutation(mutation, true);
                }
            };
        },
        uploadDocument: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var mutation = graphql_tag_1.default(templateObject_37 || (templateObject_37 = __makeTemplateObject(["\n          mutation uploadDocument ($data: DocumentCreateInput!) {\n            uploadDocument(data: $data) {\n              ", "\n            }\n          } ", "\n          "], ["\n          mutation uploadDocument ($data: DocumentCreateInput!) {\n            uploadDocument(data: $data) {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableMutation(mutation, true);
                }
            };
        },
        createChild: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var mutation = graphql_tag_1.default(templateObject_38 || (templateObject_38 = __makeTemplateObject(["\n          mutation createChild ($where: ID!,$data: CreateChildInput!) {\n            createChild(where: $where,data: $data) {\n              ", "\n            }\n          } ", "\n          "], ["\n          mutation createChild ($where: ID!,$data: CreateChildInput!) {\n            createChild(where: $where,data: $data) {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableMutation(mutation, true);
                }
            };
        },
        updateChild: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var mutation = graphql_tag_1.default(templateObject_39 || (templateObject_39 = __makeTemplateObject(["\n          mutation updateChild ($where: ID!,$data: UpdateChildInput!) {\n            updateChild(where: $where,data: $data) {\n              ", "\n            }\n          } ", "\n          "], ["\n          mutation updateChild ($where: ID!,$data: UpdateChildInput!) {\n            updateChild(where: $where,data: $data) {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableMutation(mutation, true);
                }
            };
        },
        deleteChild: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var mutation = graphql_tag_1.default(templateObject_40 || (templateObject_40 = __makeTemplateObject(["\n          mutation deleteChild ($where: ID!) {\n            deleteChild(where: $where) {\n              ", "\n            }\n          } ", "\n          "], ["\n          mutation deleteChild ($where: ID!) {\n            deleteChild(where: $where) {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableMutation(mutation, true);
                }
            };
        },
        customerLogin: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var mutation = graphql_tag_1.default(templateObject_41 || (templateObject_41 = __makeTemplateObject(["\n          mutation customerLogin ($data: CustomerLoginInput) {\n            customerLogin(data: $data) {\n              ", "\n            }\n          } ", "\n          "], ["\n          mutation customerLogin ($data: CustomerLoginInput) {\n            customerLogin(data: $data) {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableMutation(mutation, true);
                }
            };
        },
        updateCustomer: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var mutation = graphql_tag_1.default(templateObject_42 || (templateObject_42 = __makeTemplateObject(["\n          mutation updateCustomer ($where: CustomerWhereUniqueInput!,$data: CustomerUpdateInput!) {\n            updateCustomer(where: $where,data: $data) {\n              ", "\n            }\n          } ", "\n          "], ["\n          mutation updateCustomer ($where: CustomerWhereUniqueInput!,$data: CustomerUpdateInput!) {\n            updateCustomer(where: $where,data: $data) {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableMutation(mutation, true);
                }
            };
        },
        banCustomer: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var mutation = graphql_tag_1.default(templateObject_43 || (templateObject_43 = __makeTemplateObject(["\n          mutation banCustomer ($where: CustomerWhereUniqueInput!,$data: CreateBanInput!) {\n            banCustomer(where: $where,data: $data) {\n              ", "\n            }\n          } ", "\n          "], ["\n          mutation banCustomer ($where: CustomerWhereUniqueInput!,$data: CreateBanInput!) {\n            banCustomer(where: $where,data: $data) {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableMutation(mutation, true);
                }
            };
        },
        createReservation: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var mutation = graphql_tag_1.default(templateObject_44 || (templateObject_44 = __makeTemplateObject(["\n          mutation createReservation ($data: ReservationCreateInput) {\n            createReservation(data: $data) {\n              ", "\n            }\n          } ", "\n          "], ["\n          mutation createReservation ($data: ReservationCreateInput) {\n            createReservation(data: $data) {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableMutation(mutation, true);
                }
            };
        },
        updateReservation: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var mutation = graphql_tag_1.default(templateObject_45 || (templateObject_45 = __makeTemplateObject(["\n          mutation updateReservation ($where: ReservationWhereUniqueInput!,$data: ReservationUpdateInput!) {\n            updateReservation(where: $where,data: $data) {\n              ", "\n            }\n          } ", "\n          "], ["\n          mutation updateReservation ($where: ReservationWhereUniqueInput!,$data: ReservationUpdateInput!) {\n            updateReservation(where: $where,data: $data) {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableMutation(mutation, true);
                }
            };
        },
        updateNurseryConfig: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var mutation = graphql_tag_1.default(templateObject_46 || (templateObject_46 = __makeTemplateObject(["\n          mutation updateNurseryConfig ($data: NurseryConfigInput!) {\n            updateNurseryConfig(data: $data) {\n              ", "\n            }\n          } ", "\n          "], ["\n          mutation updateNurseryConfig ($data: NurseryConfigInput!) {\n            updateNurseryConfig(data: $data) {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableMutation(mutation, true);
                }
            };
        },
        updateRegistration: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var mutation = graphql_tag_1.default(templateObject_47 || (templateObject_47 = __makeTemplateObject(["\n          mutation updateRegistration ($where: RegistrationWhereUniqueInput!,$data: RegistrationUpdateInput!) {\n            updateRegistration(where: $where,data: $data) {\n              ", "\n            }\n          } ", "\n          "], ["\n          mutation updateRegistration ($where: RegistrationWhereUniqueInput!,$data: RegistrationUpdateInput!) {\n            updateRegistration(where: $where,data: $data) {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableMutation(mutation, true);
                }
            };
        },
        updateMail: function () {
            return {
                $fragment: function (fragment) {
                    var _a = guessFragmentType(fragment), isString = _a.isString, isFragment = _a.isFragment, fragmentName = _a.fragmentName;
                    var mutation = graphql_tag_1.default(templateObject_48 || (templateObject_48 = __makeTemplateObject(["\n          mutation updateMail ($where: MailWhereUniqueInput!,$data: MailUpdateInput) {\n            updateMail(where: $where,data: $data) {\n              ", "\n            }\n          } ", "\n          "], ["\n          mutation updateMail ($where: MailWhereUniqueInput!,$data: MailUpdateInput) {\n            updateMail(where: $where,data: $data) {\n              ", "\n            }\n          } ", "\n          "])), isString ? fragment : '...' + fragmentName, isFragment ? fragment : '');
                    return abortableMutation(mutation, true);
                }
            };
        }
    };
};
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8, templateObject_9, templateObject_10, templateObject_11, templateObject_12, templateObject_13, templateObject_14, templateObject_15, templateObject_16, templateObject_17, templateObject_18, templateObject_19, templateObject_20, templateObject_21, templateObject_22, templateObject_23, templateObject_24, templateObject_25, templateObject_26, templateObject_27, templateObject_28, templateObject_29, templateObject_30, templateObject_31, templateObject_32, templateObject_33, templateObject_34, templateObject_35, templateObject_36, templateObject_37, templateObject_38, templateObject_39, templateObject_40, templateObject_41, templateObject_42, templateObject_43, templateObject_44, templateObject_45, templateObject_46, templateObject_47, templateObject_48;
