"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.evaluateType = function (field) {
    var propertyName = field.name;
    var isOptional = true;
    var isArray = false;
    var isArrayOptional = false;
    var isEdge = false;
    var isScalar = false;
    var isEnum = false;
    var typeName = '';
    function getFieldInfos(type) {
        if (propertyName === 'edges')
            isEdge = true;
        if (type.kind === 'NON_NULL' || type.kind === 'LIST') {
            if (type.kind === 'LIST') {
                isArray = true;
                if (isOptional)
                    isArrayOptional = true;
            }
            if (type.kind === 'NON_NULL' && !isArrayOptional)
                isOptional = false;
            return getFieldInfos(type.ofType);
        }
        else {
            if (type.kind === 'SCALAR') {
                isScalar = true;
            }
            else if (type.kind === 'ENUM') {
                isEnum = true;
            }
            typeName = type.name;
        }
    }
    getFieldInfos(field.type);
    return {
        isOptional: isOptional,
        isArray: isArray,
        isArrayOptional: isArrayOptional,
        isEdge: isEdge,
        isScalar: isScalar,
        typeName: typeName,
        isEnum: isEnum,
    };
};
exports.isReturnTypeEdge = function (ObjectTypes, typeName) {
    return ObjectTypes.find(function (f) { return f.name === typeName; })
        .fields.map(exports.evaluateType)
        .some(function (s) { return s.isEdge; });
};
exports.areAllArgsOptional = function (args) {
    return args.map(exports.evaluateType).every(function (m) { return m.isOptional; });
};
